Subject: Re: Improved git-gui blame viewer

From: Matthijs Melchior <[email-masked]>
Date: Sat, 02 Jun 2007 12:44:29 +0200

Shawn O. Pearce wrote:
> A long time ago Linus Torvalds <[email-masked]> wrote:
>> On Sun, 18 Mar 2007, Shawn O. Pearce wrote:
>>> Linus Torvalds <[email-masked]> wrote:
>>>> Of course, the git gui blame colorization is clearly done by somebody who 
>>>> is still actively popping LSD with both fists and didn't realize that the 
>>>> 60's are long done, but that's another issue.
>>> git-gui is open source.  I'd be happy to take a patch.  Or,
>>> since that is horribly messy Tcl/Tk code, just a better color
>>> suggestion. :-)
>> I would suggest:
>>
>>  - some special color for "currently selected" (which defaults to being 
>>    the first one coming out of the blame thing, of course). 
>>
>>    I'd suggest "black text on pale green background", but that may be just 
>>    me.
>>
>>  - some *stable* graduated color for the rest. I don't think it 
>>    necessarily needs to be "older" vs "newer", and in fact I'd suggest 
>>    just two slightly different shades of gray for the background - just 
>>    pick alternating shades for each blame entry that comes in (and leave 
>>    un-blamed lines white).
> 
> I finally got the git-gui code to the point where cleaning up the
> user interface was possible without sending myself to the nut house.
> 
> I tried out Linus' suggestions for coloring, and I like them.  Enough
> that they are now sitting in my `pu` branch on repo.or.cz/git-gui.git.
> 
> There's also a whole slew of other improvements to the blame viewer,
> like being able to dig through history by clicking on commit ids,
> and tooltips when you mouse over a region of the file.
> 
> Behavior on Windows is actually quite good; its less so on Mac
> OS X.  I'm fighting Tk there a little bit more than I should be.
> Untested on Linux, so I'd love to hear some feedback on it.
> 
>   git://repo.or.cz/git-gui.git      pu
>   http://repo.or.cz/r/git-gui.git   pu
>  

I have got this on Debian Etch and given the command 'make install'
in the pu branch while git-core 1.5.2 is installed.

About git-gui says:
	git-gui version 0.7.2.39.ge6a1
	git version 1.5.2
	Tcl/Tk version 8.4.12

The colors look much better.

The behavior has some rough edges. I don't like the following:
  When clicking on a link in the left column, the file as present in
  that commit is loaded, positioned at the top. I would like for the
  line where I clicked is to stay at the same position on the screen,
  so I do not have to find it again.

  Also, when returning I would like most lines on the screen stay the
  same.

  When clicking on a light gray line to become a green line, then
  adjacent areas are not correctly colored.  A few adjacent entries
  become all same gray... [Look around git-gui.sh:340]

  Something I want for the normal window, in the Staged and Unstaged
  file lists, high-lite the last entry selected so it becomes easy to
  click on the next one and I can see more clearly what is displayed
  in the bottom area.

Thanks for your efforts!

Regards,
	Matthijs Melchior.